#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CSMime.cpp 1.4 3/24/98 16:12:18"; 
#endif

//////////////////////////////////////////////////////////////////////////
// CSM_CSMime.cpp
// These routines support the CSMIME class.

#include "sm_api.h"

//////////////////////////////////////////////////////////////////////////
void CSMIME::ClearFlag(char chClearFlag)
{
   CSM_CSInstLst *tmpInstances;

   SME_SETUP("CSMIME::ClearFlag");

   if (m_pCSInsts)
   {
      for (tmpInstances = m_pCSInsts->First(); tmpInstances;
            tmpInstances = tmpInstances->Next())
      {
         if ((chClearFlag & SM_INST_APPLICABLE) || 
               (chClearFlag & SM_INST_ALL))
            tmpInstances->Get()->SetApplicable(false);
         if ((chClearFlag & SM_INST_USE_THIS) || 
               (chClearFlag & SM_INST_ALL))
            tmpInstances->Get()->SetUseThis(false);
      }
   }
   SME_FINISH_CATCH
}

//////////////////////////////////////////////////////////////////////////
//Sets the UseThis flag on all signing capable logins
void CSMIME::UseAll()                                      
{
   CSM_AlgLst *pdigestAlgID=NULL;
   CSM_AlgLst *pdigestEncryptionAlgID=NULL;
   CSM_CSInstLst *tmpInstances;

   SME_SETUP("CSMIME::UseAll");

   if (m_pCSInsts)
   {
      for (tmpInstances = m_pCSInsts->First(); tmpInstances;
            tmpInstances=tmpInstances->Next())
         tmpInstances->Get()->SetUseThis(true);
   }
   SME_FINISH_CATCH
}

//////////////////////////////////////////////////////////////////////////
// FindCSInstAlgIds
// This function searches for any specified algorithm IDs
// in the appropriate private members algorithm lists for the specified
// algorithm.  If all specified algorithms are found, a TRUE is returned.
// Any of the parameters can be NULL; it is expected that at least one is 
// not NULL.
CSM_CSInst  *CSMIME::FindCSInstAlgIds(CSM_Alg *pdigestAlgID, 
            CSM_Alg *pdigestEncryptionAlgID,
            CSM_Alg *pkeyEncryptionAlgID,
            CSM_Alg *pcontentEncryptionAlgID)
{
   CSM_CSInstLst *tmpInstances;
   CSM_CSInst *tmpInstance = NULL;

   SME_SETUP("CSMIME::FindCSInstAlgIds");

   if (m_pCSInsts)
   {
      for (tmpInstances = m_pCSInsts->First(); tmpInstances &&
            !tmpInstances->Get()->FindAlgIds(pdigestAlgID, 
            pdigestEncryptionAlgID, pkeyEncryptionAlgID, 
            pcontentEncryptionAlgID); tmpInstances = tmpInstances->Next());
      if (tmpInstances)
         tmpInstance = tmpInstances->Get();
   }
   SME_FINISH_CATCH
   return (tmpInstance);
}

//////////////////////////////////////////////////////////////////////////
void CSMIME::InstanceLock(char chLockFlag)
{
   CSM_CSInstLst *tmpInstances;
   SME_SETUP("CSMIME::InstanceLock");
   if (m_pCSInsts)
   {
      for (tmpInstances = m_pCSInsts->First(); tmpInstances;
            tmpInstances = tmpInstances->Next())
      {
         if (chLockFlag & SM_INST_ALL)
            tmpInstances->Get()->GetTokenInterface()->SMTI_Lock();
         else
         {
            if ((chLockFlag & SM_INST_APPLICABLE) && (tmpInstances->Get()->
                  IsApplicable()))
               tmpInstances->Get()->GetTokenInterface()->SMTI_Lock();
            if ((chLockFlag & SM_INST_USE_THIS) && (tmpInstances->Get()->
                  IsThisUsed()))
               tmpInstances->Get()->GetTokenInterface()->SMTI_Lock();
         }
      }
   }
   SME_FINISH_CATCH
}

//////////////////////////////////////////////////////////////////////////
void CSMIME::InstanceUnlock(char chLockFlag)
{
   CSM_CSInstLst *tmpInstances;
   SME_SETUP("CSMIME::InstanceUnlock");
   if (m_pCSInsts)
   {
      for (tmpInstances = m_pCSInsts->First(); tmpInstances;
            tmpInstances = tmpInstances->Next())
      {
         if (chLockFlag & SM_INST_ALL)
            tmpInstances->Get()->GetTokenInterface()->SMTI_Unlock();
         else
         {
            if ((chLockFlag & SM_INST_APPLICABLE) && (tmpInstances->Get()->
                  IsApplicable()))
               tmpInstances->Get()->GetTokenInterface()->SMTI_Unlock();
            if ((chLockFlag & SM_INST_USE_THIS) && (tmpInstances->Get()->
                  IsThisUsed()))
               tmpInstances->Get()->GetTokenInterface()->SMTI_Unlock();
         }
      }
   }
   SME_FINISH_CATCH
}

// EOF CSM_CSMime.cpp
