#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_AutoAlgf.cpp 1.9 3/30/98 17:08:33"; 
#endif

// sm_AutoAlgf.cpp
//
// This file contains the low level testing calls for CTI Library Testing
// Calls should be ifdef-ed to allow selective inclusion/exclusion.

#include <stdio.h>
#include <stdlib.h>
#include "sm_util.h"

/*** 
  SM_AutoAlgFunction
  This routine handles the interpretation of configuration file entries for
  CTI Libraries.  A status is returned.
***/
SM_RET_VAL SM_AutoAlgFunction(
      char *lpszProg,
      char *lpszConfigFile,/** IN, config file name **/
      char *lpszConfigSection,/** IN, section identifying hilevel ops **/
      char *lpszOutputFile,
      long output_flag,  /** IN, print flag options **/
      long verify_flag)  /** IN, verification flag options **/
{
   long status=0;
   int testIndex=-1;        /** index of the test being executed in while().**/
   int sectionFound=0;
   short local_clear = 0;
   short depend_clear = 0;
   
   SME_SETUP("SM_AutoAlgFunction");
            /* process buf, label of hilevel function, and config file to 
               execute. */
            status = -10; // check for -10 later on
#ifdef SM_FREE_USED
            if (strcmp(lpszProg, "FREE_SMTI_Encrypt") == 0)
            {
               SME(status = SM_FreeEncryptTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_Decrypt") == 0)
            {
               SME(status = SM_FreeDecryptTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_GenerateEMEK") == 0)
            {
               SME(status = SM_FreeGenerateEMEKTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_Random") == 0)
            {
               SME(status = SM_FreeRandomTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_ExtractMEK") == 0)
            {
               SME(status = SM_FreeExtractMEKTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_Digest") == 0)
            {
               SME(status = SM_FreeDigestTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_Sign") == 0)
            {
               SME(status = SM_FreeSignTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_SMTI_Verify") == 0)
            {
               SME(status = SM_FreeVerifyTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_GenerateDSAKeys") == 0)
            {
               SME(status = SM_FreeGenerateDSAKeys(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "FREE_GenerateDHKeys") == 0)
            {
               SME(status = SM_FreeGenerateDHKeys(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
#endif

#ifdef SM_FORT_USED
#endif

#ifdef SM_RSA_USED
            if (strcmp(lpszProg, "RSA_SMTI_Encrypt") == 0)
            {
               SME(status = SM_RsaEncryptTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "RSA_SMTI_Random") == 0)
            {
               SME(status = SM_RsaRandomTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
            if (strcmp(lpszProg, "RSA_SMTI_Digest") == 0)
            {
               SME(status = SM_RsaDigestTest(lpszConfigFile, 
                     lpszConfigSection, output_flag, verify_flag));
            }
#endif
            if (status == -10)
               // we didn't do anything
               printf("NO ALG PROCESSING PERFORMED: %s ####################.\n",
                     lpszProg);

   
   SME_FINISH_CATCH

   return(status);
}

// EOF SM_AutoAlgf.cpp
