#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgCheckEncrypt.cpp 1.3 3/20/98 17:30:37"; 
#endif

//////////////////////////////////////////////////////////////////////////
// sm_CfgCheckEncrypt.cpp

#include <stdio.h>
#include "sm_util.h"

SM_RET_VAL SM_CfgCheckEncrypt(char *pszCfgFile, CSMIME *pCSMIME,
                              long output_flag, long verify_flag)
{
   char *pszOrigCfgFile = SM_SetCfgFn(pszCfgFile);
   SM_RET_VAL lRet = SM_NO_ERROR;
   CSM_EncryptMsg smEncryptMsg;
   KwValue kwEncodedResult;

   SME_SETUP("SM_CfgCheckEncrypt");

   if (pCSMIME == NULL)
      SME_THROW(SM_MISSING_PARAM, NULL, NULL);

   // fill the CSM_EncryptMsg class
   if (output_flag == 1)
      printf("SM_CfgCheckEncrypt: filling CSM_EncryptMsg\n");
   SME(SM_CfgFillEncryptMsg(pCSMIME, &smEncryptMsg, "EnvelopedDataTest"));

   // call CSM_EncryptMsg::Encrypt to do the real work
   if (output_flag == 1)
      printf("SM_CfgCheckEncrypt: calling Encrypt\n");
   SME(smEncryptMsg.Encrypt(pCSMIME));
   if (output_flag != -1)
      printf("SM_CfgCheckEncrypt: returned SM_NO_ERROR!!!\n");

   // convert the result to file (TBD, done right?)
   if ((lRet = SM_GetKwValue("EncodedEnvelopedDataFN", kwEncodedResult,
            "EnvelopedDataTest")) != SM_NO_ERROR)
      SME_THROW(lRet, "EncodedEnvelopedDataFN kw missing", NULL);
   SME(smEncryptMsg.GetEncodedBlob()->ConvertMemoryToFile(kwEncodedResult));
   if (output_flag == 1)
      printf("SM_CfgCheckEncrypt: converted result to file %s\n", 
            kwEncodedResult);

   if (output_flag == 1)
      printf("SM_CfgCheckEncrypt: warning, verify not implemented yet\n");

   SM_SetCfgFn(pszOrigCfgFile); // restore orig config file

   SME_FINISH
   SME_CATCH_SETUP
      // catch/cleanup logic as necessary
      // result original cfg file?
   SME_CATCH_FINISH

   return lRet;
}

// EOF sm_CfgCheckEncrypt.cpp
