#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgCheckSignedData.cpp 1.7 3/26/98 11:51:28"; 
#endif

/* sm_CfgCheckSignedData.cpp */
#include <stdio.h>
#include "sm_util.h"

SM_RET_VAL SM_WriteBuf2File(char *buf, long bufsize, char *filename);


SM_RET_VAL SM_CfgCheckSignedData(char *pszCfgFile, CSMIME *pCsmime,
      long output_flag, long verify_flag)
{
   //KwValue kwValue;
   KwValue fn;
   char *pszOrigCfgFile = SM_SetCfgFn(pszCfgFile); /* set config file */
   SM_RET_VAL ret = SM_NO_ERROR;
   CSM_ErrorBuf error;
   CSM_SignMsg smSignMsg;       // Default constructor
   CSM_SignMsg *pSignMsg=NULL;
   KwValue kwValue;


    SME_SETUP("SM_CfgCheckSignedData");
   /* fill a SM_Signed_data */
   if (output_flag == 1)
      printf("SM_CfgCheckSignedData: filling...\n");
   if (SM_GetKwValue("contentFILE", kwValue, "SignedDataTest") == SM_NO_ERROR && 
       !strstr(kwValue, "NULL"))
   {
       CSM_Buffer *p;
       pSignMsg = new CSM_SignMsg((p=new CSM_Buffer((char *)kwValue)));
                        // CREATE SignedData class instance with file buffer.
       delete p;
   }
   else
   {
        pSignMsg = &smSignMsg;
   }

   {
      if ((ret = SM_GetKwValue("EncodedSignDataFN", fn, "SignedDataTest")) ==
            SM_NO_ERROR)
      {
         if ((ret = SM_CfgSignedData(pCsmime, pSignMsg, "SignedDataTest")) 
             == SM_NO_ERROR)
         {
            /* ASN.1 encode the receipt */
            if (output_flag == 1)
               printf("SM_CfgCheckSignedData: encoding...\n");
            if ((ret = pSignMsg->Sign(pCsmime)) == SM_NO_ERROR)
            {
               if (output_flag == 1)
               {
                  //printf("SM_CfgCheckSignedData: prt C structure...\n");
                  //SM_PrtSignData(&smSignMsg);
                  //printf("\nSM_CfgCheckSignedData:  printing asn.1...\n");
                  //SM_PrtHex(Result.str, Result.lgth);
                  printf("\n");
                  printf("SM_CfgCheckSignedData: writing SignData to %s\n",
                        fn);
               }
               if (output_flag != -1)
                  printf("\nSM_CheckSignedData returned SM_NO_ERROR\n");
               //SM_WriteBuf2File((char *)smSignMsg.GetEncodedBlob(), 
               //    smSignMsg.GetEncodedBlob()->Length(), fn);
               SME(pSignMsg->GetEncodedBlob()->ConvertMemoryToFile(fn));
            }
            else
            {
               printf("SM_CfgCheckSignedData: Sign returned %ld\n",
                     ret);
               SME_THROW(22, "Sign() failed.", NULL);
            }
         }
         else
            printf("SM_CfgCheckSignedData: SM_CfgSignedData returned %ld\n",
                  ret);
      }
      else
         printf("SM_CfgCheckSignedData: missing EncodedSignDataFN kw\n");
   }
   //else
   //   printf("SM_CfgCheckSignedData: missing SignedDataSection kw\n");

   // free?
   SM_SetCfgFn(pszOrigCfgFile);
   if (pSignMsg != &smSignMsg)  // if dynamically allocated...
       delete pSignMsg;

   SME_FINISH_CATCH

   return ret;
}

#ifdef BOB
SM_RET_VAL SM_CfgCheckDecSignData(char *pszCfgFile, 
      short output_flag, short verify_flag)
{
   KwValue fn;
   char *pszOrigCfgFile = SM_SetCfgFn(pszCfgFile); /* set config file */
   SM_RET_VAL ret = SM_NO_ERROR;
   SM_Signed_data *pSignData = NULL;
   SM_Str_struct result;
   SM_Buf_file bf;
   SM_ErrorBuf error;

   memset(&error, 0, sizeof(SM_ErrorBuf));

   if ((ret = SM_GetKwValue("EncodedSignDataFN", fn, "DecSignDataTest")) == 
            SM_NO_ERROR)
   {
      if (output_flag == 1)
         printf("SM_CfgCheckDecSignData: reading from %s\n", fn);
      memset(&bf, 0, sizeof(SM_Buf_file));
      SM_ReadBufFromFile(&bf, fn);
      result.str = bf.data;
      result.lgth = bf.lgth;
      pSignData = (SM_Signed_data *)calloc(1, sizeof(SM_Signed_data));
      /* ASN.1 decode the receipt */
      if (output_flag == 1)
         printf("SM_CfgCheckDecSignData: decoding...\n");
      if ((ret = SM_DecSignData(pSignData, &result,
         &error)) == SM_NO_ERROR)
      {
         if (output_flag = 1)
         {
            printf("SM_CfgCheckDecSignData: printing C structure...\n");
            SM_PrtSignData(pSignData);
         }
         if (output_flag != -1)
            printf("SM_DecSignData returned SM_NO_ERROR\n");
      }
      else
         printf("SM_CfgCheckDecSignData: SM_DecSignData returned %ld\n", ret); 
   }
   else
      printf("SM_CfgCheckDecSignData: missing EncodedSignDataFN kw\n");

   // free?
   SM_SetCfgFn(pszOrigCfgFile);
   return ret;
}
#endif
/* EOF sm_CfgCheckSignedData.cpp */
