#ifndef NO_SCCS_ID
static char SccsId[ ] = "@(#) sm_CfgSignedData.cpp 1.10 3/30/98 11:33:42"; 
#endif

#include <stdio.h>
#include "sm_util.h"
SM_RET_VAL SM_CfgCertsSection(char *lpszSection, CSM_MsgCertCrls *pMsgCertsCrls);


SM_RET_VAL SM_CfgSignedData(CSMIME *pCsmime, CSM_SignMsg *pSignedData, 
                            Section section)
{
   KwValue kwValue;
   SM_RET_VAL ret = SM_NO_ERROR;
   CSM_Buffer *pBuf=NULL;
   char lpszLoginBuf[20];
   int i=1;
   CSM_CSInstLst *tmpCSInsts = NULL;
   SM_RET_VAL status=0;

   if (pSignedData != NULL)
   {
         sprintf(lpszLoginBuf, "Login%d", i++);
         pCsmime->ClearFlag(SM_INST_USE_THIS);   // CLEAR ALL UseThis flags.
         while (ret == SM_NO_ERROR &&     // For each CSInstance login entry
            SM_GetKwValue(lpszLoginBuf, kwValue, section) == SM_NO_ERROR)
         {
            if (pCsmime->m_pCSInsts)
             for (tmpCSInsts=pCsmime->m_pCSInsts->First(); tmpCSInsts && 
                strcmp(kwValue, tmpCSInsts->Get()->GetID()) != 0; 
                tmpCSInsts=tmpCSInsts->Next());     
                                            // search for matching logged on ID
            if (tmpCSInsts == NULL)
            {
              for (tmpCSInsts=pCsmime->m_pCSInsts->First(); tmpCSInsts;
                tmpCSInsts=tmpCSInsts->Next())
              {
                  CSM_DN *pTmpDN;
                  pTmpDN = tmpCSInsts->Get()->GetSubjectDN();
                  if (strcmp(kwValue, pTmpDN->GetDNString()) == 0)
                      break;
              }             // search for matching logged on DN
            }
            if (tmpCSInsts)
            {
                tmpCSInsts->Get()->SetUseThis();  
                                      // Set to use in SignerInfo of SiengeData.
            }
            sprintf(lpszLoginBuf, "Login%d", i++);  // prepare for next keyword.
         }
         if (SM_GetKwValue("contentBUFFER", kwValue, 
              section) == SM_NO_ERROR && !strstr(kwValue, "NULL"))
         {
             pBuf = new CSM_Buffer((char *)kwValue, strlen(kwValue));
         }
         else if (SM_GetKwValue("contentFILE", kwValue, 
              section) == SM_NO_ERROR && !strstr(kwValue, "NULL"))
         {
             pBuf = new CSM_Buffer((char *)kwValue);
         }
         if (pBuf)
         {
             pSignedData->SetEncapContent(pBuf,
                 CSM_Content::CONTENT_DATA_DATA); 
             if ((ret = SM_GetKwValue("contentOID", kwValue, 
                  section)) == SM_NO_ERROR)
             {
                 pSignedData->setContentType(CSM_OID(kwValue));
             }
             else
                printf("SM_CfgSignData: missing contentOID, with contentFILE present,%s.\n",
                    kwValue);
         }

         if (SM_GetKwValue("cert_path_issuer", kwValue, 
              section) == SM_NO_ERROR && !strstr(kwValue, "NULL"))
         {
             pSignedData->SetIncludeOrigCertsFlag(atol(kwValue)!=0);
         }

         if (SM_GetKwValue("MsgCertCrls", kwValue, section) == 
              SM_NO_ERROR && !strstr(kwValue, "NULL"))
         {
             pSignedData->m_pMsgCertCrls = new CSM_MsgCertCrls;
             status = SM_CfgCertsSection(kwValue, pSignedData->m_pMsgCertCrls);
          }
          else
              printf("CfgSignData: missing certificates value\n");

          if (SM_GetKwValue("crls", kwValue, section) == 
                   SM_NO_ERROR && !strstr(kwValue, "NULL"))
          {
              if (pSignedData->m_pMsgCertCrls == NULL)
              {             // ONLY if they have not alread been created.
                 pSignedData->m_pMsgCertCrls = new CSM_MsgCertCrls;
              }
              //      ret = SM_CfgCrlLst(&((*pSignData)->crls), kwValue);
          }
   }


   return ret;
}

/* EOF SM_CfgSignData.c */
